#!/bin/sh

export LD_LIBRARY_PATH=$CUDA_PATH/lib64:$LD_LIBRARY_PATH

#GPU=GTXTitanBlack
#GPU=TeslaK20c
#GPU=GTX580
#GPU=GTX750Ti

IN=IN
IN=IN-large
IN=IN-HPC148
IN=IN-HPC151

IN_FROM=16
IN_TO=20000
IN_STEP=16
awk 'BEGIN{ print 1; for(i='$IN_FROM';i<='$IN_TO';i+='$IN_STEP'){ print i; } print -1; exit; }' > $IN

GPU=`../src/get_dev_info | awk '/DEVICE/{ gsub(/^[A-Za-z0-9]*-/,"",$2); gsub(/-/,""); print $2; }'`

EXEC=''
OPTIONAL=-large
OPTIONAL=''
OPTIONAL='-HPC151'

#$EXEC ./test2-sgemv-n $IN | tee log-ASPEN.K2-1.5p4-SGEMVN-$GPU$OPTIONAL
#$EXEC ./test2-sgemv-t $IN | tee log-ASPEN.K2-1.5p4-SGEMVT-$GPU$OPTIONAL
$EXEC ./test2-ssymv-u $IN | tee log-ASPEN.K2-1.5p5-SSYMVU-$GPU$OPTIONAL
$EXEC ./test2-ssymv-l $IN | tee log-ASPEN.K2-1.5p5-SSYMVL-$GPU$OPTIONAL

#$EXEC ./test2-dgemv-n $IN | tee log-ASPEN.K2-1.5p4-DGEMVN-$GPU$OPTIONAL
#$EXEC ./test2-dgemv-t $IN | tee log-ASPEN.K2-1.5p4-DGEMVT-$GPU$OPTIONAL
$EXEC ./test2-dsymv-u $IN | tee log-ASPEN.K2-1.5p5-DSYMVU-$GPU$OPTIONAL
$EXEC ./test2-dsymv-l $IN | tee log-ASPEN.K2-1.5p5-DSYMVL-$GPU$OPTIONAL

exit

#$EXEC ./cuda-sgemv-n $IN | tee log-CUDA-7.0-SGEMVN-$GPU$OPTIONAL
#$EXEC ./cuda-sgemv-t $IN | tee log-CUDA-7.0-SGEMVT-$GPU$OPTIONAL
#$EXEC ./cuda-ssymv-u $IN | tee log-CUDA-7.0-SSYMVU-$GPU$OPTIONAL
#$EXEC ./cuda-ssymv-l $IN | tee log-CUDA-7.0-SSYMVL-$GPU$OPTIONAL

#$EXEC ./cuda-dgemv-n $IN | tee log-CUDA-7.0-DGEMVN-$GPU$OPTIONAL
#$EXEC ./cuda-dgemv-t $IN | tee log-CUDA-7.0-DGEMVT-$GPU$OPTIONAL
#$EXEC ./cuda-dsymv-u $IN | tee log-CUDA-7.0-DSYMVU-$GPU$OPTIONAL
#$EXEC ./cuda-dsymv-l $IN | tee log-CUDA-7.0-DSYMVL-$GPU$OPTIONAL

#$EXEC ./magma-sgemv-n $IN | tee log-MAGMA-1.6.1-SGEMVN-$GPU$OPTIONAL
#$EXEC ./magma-sgemv-t $IN | tee log-MAGMA-1.6.1-SGEMVT-$GPU$OPTIONAL
$EXEC ./magma-ssymv-u $IN | tee log-MAGMA-1.6.1-SSYMVU-$GPU$OPTIONAL
$EXEC ./magma-ssymv-l $IN | tee log-MAGMA-1.6.1-SSYMVL-$GPU$OPTIONAL
$EXEC ./magma2-ssymv-u $IN | tee log-MAGMA2-1.6.1-SSYMVU-$GPU$OPTIONAL
$EXEC ./magma2-ssymv-l $IN | tee log-MAGMA2-1.6.1-SSYMVL-$GPU$OPTIONAL

#$EXEC ./magma-dgemv-n $IN | tee log-MAGMA-1.6.1-DGEMVN-$GPU$OPTIONAL
#$EXEC ./magma-dgemv-t $IN | tee log-MAGMA-1.6.1-DGEMVT-$GPU$OPTIONAL
$EXEC ./magma-dsymv-u $IN | tee log-MAGMA-1.6.1-DSYMVU-$GPU$OPTIONAL
$EXEC ./magma-dsymv-l $IN | tee log-MAGMA-1.6.1-DSYMVL-$GPU$OPTIONAL
$EXEC ./magma2-dsymv-u $IN | tee log-MAGMA2-1.6.1-DSYMVU-$GPU$OPTIONAL
$EXEC ./magma2-dsymv-l $IN | tee log-MAGMA2-1.6.1-DSYMVL-$GPU$OPTIONAL

#$EXEC ./kblas-sgemv-n $IN | tee log-KBLAS-1.2-SGEMVN-$GPU$OPTIONAL
#$EXEC ./kblas-sgemv-t $IN | tee log-KBLAS-1.2-SGEMVT-$GPU$OPTIONAL
$EXEC ./kblas-ssymv-u $IN | tee log-KBLAS-1.2-SSYMVU-$GPU$OPTIONAL
$EXEC ./kblas-ssymv-l $IN | tee log-KBLAS-1.2-SSYMVL-$GPU$OPTIONAL

#$EXEC ./kblas-dgemv-n $IN | tee log-KBLAS-1.2-DGEMVN-$GPU$OPTIONAL
#$EXEC ./kblas-dgemv-t $IN | tee log-KBLAS-1.2-DGEMVT-$GPU$OPTIONAL
$EXEC ./kblas-dsymv-u $IN | tee log-KBLAS-1.2-DSYMVU-$GPU$OPTIONAL
$EXEC ./kblas-dsymv-l $IN | tee log-KBLAS-1.2-DSYMVL-$GPU$OPTIONAL


