#if 0
<--/****************************************
Automatic Performance Tuning for DGEMV -T
2015年  4月 14日 火曜日 16:38:08 JST
Host on gauss.aics27.riken.jp
Device is GeForce-GTX-580
****************************************/-->
#endif
#if 0
char* _AT_tuned_host="gauss.aics27.riken.jp";
char* _AT_tuned_device="GeForce-GTX-580";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


#if !defined(API)
#define API(x)			x
#define get_numbers_MP(...)	(16)
#endif
#if !defined(scalar_t)
#define scalar_t	double
#endif

#define _NAME_     _NAME_4PARAMS_


long
do_best_kernel_DGEMVT(int blk, const scalar_t alpha, const scalar_t beta,
	const scalar_t *a, const scalar_t *x, scalar_t *y,
	int lda, int n1, int n2, int offsetX, double *ff)
{
	long t=0;
	int n=n1;
	int BLK=0;

#define	KERNEL_4	1
#define	KERNEL_5	1
#define	KERNEL_19	1
#define	KERNEL_7	1
#define	KERNEL_11	1
#define	KERNEL_13	1
#define	KERNEL_0	1
#define	KERNEL_14	1
#define	KERNEL_2	1
#define	KERNEL_15	1
#define	KERNEL_3	1

if ( n >= 1 && n < 205 ) {
	BLK = 19;
} else
if ( n >= 205 && n < 542 ) {
	BLK = 2;
} else
if ( n >= 542 && n < 576 ) {
	BLK = 13;
} else
if ( n >= 576 && n < 1024 ) {
	BLK = 2;
} else
if ( n >= 1024 && n < 1074 ) {
	BLK = 5;
} else
if ( n >= 1074 && n < 1280 ) {
	BLK = 0;
} else
if ( n >= 1280 && n < 1524 ) {
	BLK = 5;
} else
if ( n >= 1524 && n < 1536 ) {
	BLK = 0;
} else
if ( n >= 1536 && n < 2500 ) {
	BLK = 3;
} else
if ( n >= 2500 && n < 2560 ) {
	BLK = 5;
} else
if ( n >= 2560 && n < 2843 ) {
	BLK = 3;
} else
if ( n >= 2843 && n < 3072 ) {
	BLK = 5;
} else
if ( n >= 3072 && n < 3292 ) {
	BLK = 3;
} else
if ( n >= 3292 && n < 3775 ) {
	BLK = 5;
} else
if ( n >= 3775 && n < 3840 ) {
	BLK = 15;
} else
if ( n >= 3840 && n < 4061 ) {
	BLK = 5;
} else
if ( n >= 4061 && n < 4096 ) {
	BLK = 14;
} else
if ( n >= 4096 && n < 4224 ) {
	BLK = 15;
} else
if ( n >= 4224 && n < 4426 ) {
	BLK = 5;
} else
if ( n >= 4426 && n < 4608 ) {
	BLK = 14;
} else
if ( n >= 4608 && n < 4634 ) {
	BLK = 5;
} else
if ( n >= 4634 && n < 4992 ) {
	BLK = 15;
} else
if ( n >= 4992 && n < 5120 ) {
	BLK = 14;
} else
if ( n >= 5120 && n < 5376 ) {
	BLK = 15;
} else
if ( n >= 5376 && n < 5632 ) {
	BLK = 14;
} else
if ( n >= 5632 && n < 6013 ) {
	BLK = 15;
} else
if ( n >= 6013 && n < 6048 ) {
	BLK = 11;
} else
if ( n >= 6048 && n < 6144 ) {
	BLK = 15;
} else
if ( n >= 6144 && n < 6240 ) {
	BLK = 7;
} else
if ( n >= 6240 && n < 6528 ) {
	BLK = 15;
} else
if ( n >= 6528 && n < 6600 ) {
	BLK = 14;
} else
if ( n >= 6600 && n < 6656 ) {
	BLK = 4;
} else
if ( n >= 6656 && n < 6720 ) {
	BLK = 11;
} else
if ( n >= 6720 && n < 6912 ) {
	BLK = 15;
} else
if ( n >= 6912 && n < 7040 ) {
	BLK = 14;
} else
if ( n >= 7040 && n < 7168 ) {
	BLK = 4;
} else
if ( n >= 7168 && n < 7200 ) {
	BLK = 7;
} else
if ( n >= 7200 && n < 7296 ) {
	BLK = 15;
} else
if ( n >= 7296 && n < 7392 ) {
	BLK = 11;
} else
if ( n >= 7392 && n < 7585 ) {
	BLK = 15;
} else
if ( n >= 7585 && n < 7680 ) {
	BLK = 7;
} else
if ( n >= 7680 && n < 7746 ) {
	BLK = 15;
} else
if ( n >= 7746 && n < 8064 ) {
	BLK = 11;
} else
if ( n >= 8064 && n < 8160 ) {
	BLK = 7;
} else
if ( n >= 8160 && n < 8192 ) {
	BLK = 4;
} else
if ( n >= 8192 && n < 8448 ) {
	BLK = 15;
} else
if ( n >= 8448 && n < 8640 ) {
	BLK = 7;
} else
if ( n >= 8640 && n < 8736 ) {
	BLK = 11;
} else
if ( n >= 8736 && n < 8832 ) {
	BLK = 15;
} else
if ( n >= 8832 && n < 9120 ) {
	BLK = 7;
} else
if ( n >= 9120 && n < 9216 ) {
	BLK = 4;
} else
if ( n >= 9216 && n < 9408 ) {
	BLK = 11;
} else
if ( n >= 9408 && n < 9600 ) {
	BLK = 7;
} else
if ( n >= 9600 && n < 9728 ) {
	BLK = 4;
} else
if ( n >= 9728 && n < 10080 ) {
	BLK = 11;
} else
if ( n >= 10080 && n < 10240 ) {
	BLK = 4;
} else
if ( n >= 10240 && n < 10560 ) {
	BLK = 7;
} else
if ( n >= 10560 && n < 10752 ) {
	BLK = 11;
} else
if ( n >= 10752 && n < 11040 ) {
	BLK = 7;
} else
if ( n >= 11040 && n < 11424 ) {
	BLK = 11;
} else
if ( n >= 11424 && n < 11520 ) {
	BLK = 7;
} else
if ( n >= 11520 && n < 11534 ) {
	BLK = 11;
} else
if ( n >= 11534 && n < 11776 ) {
	BLK = 4;
} else
if ( n >= 11776 && n < 12000 ) {
	BLK = 7;
} else
if ( n >= 12000 && n < 12096 ) {
	BLK = 11;
} else
if ( n >= 12096 && n < 12480 ) {
	BLK = 7;
} else
if ( n >= 12480 && n < 12768 ) {
	BLK = 11;
} else
if ( n >= 12768 && n < 12960 ) {
	BLK = 7;
} else
if ( n >= 12960 && n < 13440 ) {
	BLK = 11;
} else
if ( n >= 13440 && n < 13477 ) {
	BLK = 7;
} else
if ( n >= 13477 && n < 100000000 ) {
	BLK = 7;
}

#if 1
	int ii=BLK;
#define DGEMVT_KERNEL_(BLOCK_SIZE,VMAX,UMAX,UNROLL) \
		GEMVT_KERNEL < GPU_ARCH, scalar_t, BLOCK_SIZE, VMAX, UMAX, UNROLL > \
		( alpha, beta, a, x, y, lda, n1, n2, offsetX )

	switch (ii) {
#if	KERNEL_0
	case 0:
		DGEMVT_KERNEL_ ( 160 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_1
	case 1:
		DGEMVT_KERNEL_ ( 64 , 4 , 2, 1 );
		break;
#endif
#if	KERNEL_2
	case 2:
		DGEMVT_KERNEL_ ( 48 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_3
	case 3:
		DGEMVT_KERNEL_ ( 192 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_4
	case 4:
		DGEMVT_KERNEL_ ( 64 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_5
	case 5:
		DGEMVT_KERNEL_ ( 96 , 2 , 4, 1 );
		break;
#endif
#if	KERNEL_6
	case 6:
		DGEMVT_KERNEL_ ( 160 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_7
	case 7:
		DGEMVT_KERNEL_ ( 64 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_8
	case 8:
		DGEMVT_KERNEL_ ( 64 , 3 , 4, 1 );
		break;
#endif
#if	KERNEL_9
	case 9:
		DGEMVT_KERNEL_ ( 48 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_10
	case 10:
		DGEMVT_KERNEL_ ( 192 , 1 , 3, 1 );
		break;
#endif
#if	KERNEL_11
	case 11:
		DGEMVT_KERNEL_ ( 64 , 2 , 3, 1 );
		break;
#endif
#if	KERNEL_12
	case 12:
		DGEMVT_KERNEL_ ( 128 , 2 , 2, 1 );
		break;
#endif
#if	KERNEL_13
	case 13:
		DGEMVT_KERNEL_ ( 48 , 3 , 2, 1 );
		break;
#endif
#if	KERNEL_14
	case 14:
		DGEMVT_KERNEL_ ( 96 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_15
	case 15:
		DGEMVT_KERNEL_ ( 128 , 1 , 4, 1 );
		break;
#endif
#if	KERNEL_16
	case 16:
		DGEMVT_KERNEL_ ( 128 , 1 , 7, 1 );
		break;
#endif
#if	KERNEL_17
	case 17:
		DGEMVT_KERNEL_ ( 96 , 1 , 6, 1 );
		break;
#endif
#if	KERNEL_18
	case 18:
		DGEMVT_KERNEL_ ( 160 , 1 , 5, 1 );
		break;
#endif
#if	KERNEL_19
	case 19:
		DGEMVT_KERNEL_ ( 48 , 3 , 4, 1 );
		break;
#endif
	default:
		fprintf(stderr,"Illegal BLK parameter\n");
		break;
	}
#endif
	return t;
}

